# $Id: ModMath.pm,v 1.4 2007/02/16 19:49:31 bobzilla Exp $
# Copyright (c) 2003-2004 Robert Hagemann <bobzilla@gothictech.com>
#
# Permission to use, copy, modify, and distribute this software for any
# purpose with or without fee is hereby granted, provided that the above
# copyright notice and this permission notice appear in all copies.
#
# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
# ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
# ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

package ModMath;

@ModMath::ISA = qw(OmniMod);

use strict;

my $on = 1;

sub help {
  return if ! $on;

  if ( defined wantarray ) { # do we have help?
    return 1;
  }

  my $this = shift;
  my $irc = shift;
  my $nick = shift;
  my $message = shift;

	$irc->notice( $nick, "[<math expression>] do math" );
}

sub name() {
  my $this = shift;
  return "math";
}

sub handleMessage {
  my $this = shift;
  my $irc = shift;
  my $channel = shift;
  my $nick = shift;
  my $message = shift;
  my $event = shift;

  return if ! $on;

  my $output = &checkAnyMessage( $irc, $nick, $message, $channel, 0 );
	&ModChatLog::saveMessage('omnicron', $output, $channel )
    if defined $output and $output !~ /^\s*$/si;
}

sub handlePrivateMessage {
  my $this = shift;
  my $irc = shift;
  my $nick = shift;
  my $message = shift;
  my $event = shift;

  return if ! $on;

  &checkAnyMessage( $irc, $nick, $message, $nick, 1 );
}

sub checkAnyMessage {
  my $irc = shift;
  my $nick = shift;
  my $message = shift;
  my $sendTo = shift;
  my $isPrivate = shift;

  my $output;

  if ( $message =~ /^\s*(-?[\d\.]+)\s*(\s*([\-\+\*\/\&\^\|\~\%\>\<]){1,2}\s*(-?[\d\.]+)\s*)+\s*$/si ) {
    if ( $message =~ /\/\s*0\s*$/ ) {
      $output = "i just saw goddess";
    }
    else {
      my $answer = eval( $message );
      if ( defined $answer and $answer !~ /^\s*$/si and ! $@ ) {
        $output = $answer;
      }
    }
  }
  elsif ( $message =~ /^\s*rot13\s+(.*)\s*$/si ) {
    $output = $1;
    $output =~ y/A-Za-z/N-ZA-Mn-za-m/;
  }
  elsif ( $message =~ /^\s*(\d+)\s*\!\s*$/si ) {
    $output = &factorial( $1 );
  }

  $irc->privmsg( $sendTo, $output ) if defined $output;

  return $output;
}

sub factorial {
  my $value = shift;
  my $output;
  if ( $value > 200 ) {
    $output = "so...big...";
  }
  else {
    $output = 1;
    for ( my $i = 1; $i <= $value; $i++ ) {
      $output *= $i;
    }
  }

  return $output;
}

1;
